'$DYNAMIC
DECLARE FUNCTION TimerElapsed% (TheTimer%)
DECLARE FUNCTION ADDLONGWRAP& (BYVAL A&, BYVAL B&)

DECLARE FUNCTION WINTIMER&
DECLARE SUB INITWINTIMER


TYPE LONGTimerType
    Duration AS LONG
    Start AS LONG
    Final AS LONG
    'Elapsed AS LONG
END TYPE

DIM SHARED Timers(0 TO 0) AS LONGTimerType

FUNCTION TimerElapsed% (TheTimer%)
    IF Timers(TheTimer%).Duration = 0 THEN EXIT FUNCTION
    Tim& = WINTIMER 'Freeze a moving target
    IF Tim& < Timers(TheTimer%).Start THEN
      IF Timers(TheTimer%).Final < Timers(TheTimer%).Start THEN
        IF Tim& < Timers(TheTimer%).Final THEN EXIT FUNCTION
      END IF
    ELSE
      IF Timers(TheTimer%).Final < Timers(TheTimer%).Start THEN EXIT FUNCTION
    END IF
    
       Timers(TheTimer%).Duration = 0 'Comment this out if you want
'to stop the timer triggering manually
       TimerElapsed% = -1
   
END FUNCTION

REM $STATIC
SUB TimersDestroy
    ERASE Timers
END SUB

REM $DYNAMIC
SUB TimersInit (HowMany%)
    INITWINTIMER
    SHARED Timers() AS LONGTimerType
    REDIM Timers(0 TO HowMany%) AS LONGTimerType
END SUB

SUB TimerStart (TimerToStart%, Duration AS LONG)
    Timers(TimerToStart%).Duration = Duration
    IF Timers(TimerToStart%).Duration <> 0 THEN EXIT SUB 'Trying to start an already
'started timer
    Timers(TimerToStart%).Start = WINTIMER
    Timers(TimerToStart%).Final = ADDLONGWRAP(Timers(TimerToStart%).Start, Duration)
END SUB

SUB TimerStop (TimerToStop%)
    'Stops the timer without triggering
    Timers(TimerToStop%).Duration = 0
END SUB

